/*
 * Copyright (C) 2000-2002 HighPoint Technologies, Inc.
 * HPT3xx UDMA/ATA RAID Controller Device Driver for Linux
 * File:	hpt.h
 */
#ifndef _HPT_H_
#define _HPT_H_

// function prototypes
int hpt3xx_Detect			(Scsi_Host_Template *tpnt);
int hpt3xx_Command			(Scsi_Cmnd *SCpnt);
int hpt3xx_QueueCommand		(Scsi_Cmnd *SCpnt, void (*done)(Scsi_Cmnd *));
int hpt3xx_Abort			(Scsi_Cmnd *SCpnt);
int hpt3xx_Reset			(Scsi_Cmnd *SCpnt, unsigned int flags);
int hpt3xx_Release			(struct Scsi_Host *pshost);
int hpt3xx_BiosParam		(Disk *disk, kdev_t dev, int geom[]);
int hpt3xx_ProcInfo			(char *buffer, char **start, off_t offset,
		       				int length, int hostno, int inout);

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,3,0)
#define HPT3xx {\
	proc_name:			PROC_DIR_NAME,\
	proc_info:			hpt3xx_ProcInfo,\
	name:				PROC_DIR_NAME,\
	detect:				hpt3xx_Detect,		\
	release:			hpt3xx_Release,		\
	command:			hpt3xx_Command,		\
	queuecommand:		hpt3xx_QueueCommand,\
	abort:				hpt3xx_Abort,		\
	reset:				hpt3xx_Reset,		\
	bios_param:			hpt3xx_BiosParam,	\
	can_queue:			HPT_MAX_CMDS,		\
	this_id:			-1,					\
	sg_tablesize:		16,					\
	cmd_per_lun:		1,					\
	present:			0,					\
	unchecked_isa_dma:	0,					\
	use_clustering:		DISABLE_CLUSTERING,	\
    use_new_eh_code:	0					\
}

#else /* 2.2.x */

extern struct proc_dir_entry proc_scsi_hpt3xx;

#define HPT3xx {\
	proc_dir:			&proc_scsi_hpt3xx, \
	proc_info:			hpt3xx_ProcInfo,\
	name:				PROC_DIR_NAME,\
	detect:				hpt3xx_Detect,		\
	release:			hpt3xx_Release,		\
	command:			hpt3xx_Command,		\
	queuecommand:		hpt3xx_QueueCommand,\
	abort:				hpt3xx_Abort,		\
	reset:				hpt3xx_Reset,		\
	bios_param:			hpt3xx_BiosParam,	\
	can_queue:			HPT_MAX_CMDS,		\
	this_id:			-1,					\
	sg_tablesize:		16,					\
	cmd_per_lun:		1,					\
	present:			0,					\
	unchecked_isa_dma:	0,					\
	use_clustering:		DISABLE_CLUSTERING,	\
    use_new_eh_code:	1					\
}
#endif

#endif /*_HPT_H_*/
