/*
 * Copyright (C) 2000-2002 HighPoint Technologies, Inc.
 * HPT3xx UDMA/ATA RAID Controller Device Driver for Linux
 * File:	hptkern.h
 */
#ifndef _HPTKERN_H_
#define _HPTKERN_H_

#ifndef HPT_DEFINE_VERSION
#define __NO_VERSION__
#endif

#include <linux/config.h>
#include <linux/version.h>
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,5)
#include <linux/modversions.h>
#endif

#ifdef MODULE
	#include <linux/module.h>
	#ifdef MODVERSIONS
		#include <linux/modversions.h>
	#endif
	#ifdef HPT_DEFINE_VERSION
		#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,0)
			char kernel_version[] = UTS_RELEASE;
			MODULE_AUTHOR ("HighPoint Technologies, Inc.");
			MODULE_DESCRIPTION ("Driver for HPT37x2");
		#endif
	#endif
#endif

#include <linux/sched.h>
#include <linux/blk.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <linux/pci.h>
#include <linux/wait.h>
#include <linux/ioport.h>
#include <linux/delay.h>
#include <linux/proc_fs.h>
#include <linux/interrupt.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/smp_lock.h>

#include <asm/io.h>
#include <asm/system.h>
#include <asm/dma.h>
#include <asm/uaccess.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,3,0) /* 0x20300 */
	#include <asm/spinlock.h>
#else
	#include <linux/spinlock.h>
#endif

#include <linux/stat.h>

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,1,0)
#include <linux/reboot.h>
#endif

#ifndef DECLARE_MUTEX_LOCKED
#define DECLARE_MUTEX_LOCKED(sem) struct semaphore sem = MUTEX_LOCKED
#endif

#include "scsi.h"
#include "sd.h"
#include "hosts.h"
#include "constants.h"

#include <linux/types.h>
#include <linux/kdev_t.h>

#ifndef LINUX_VERSION_CODE
#include <linux/version.h>
#endif 

#define	LINUXVERSION(v,p,s)    (((v)<<16) + ((p)<<8) + (s))

#endif /*_HPTKERN_H_*/
