
# Copyright (C) 2000-2004 HighPoint Technologies, Inc.
# rules.mak for HPT370/372/372A Linux driver
#

# Default Settings
SUPPORT_ALARM = 1

#
# Driver version number.
#
ifndef DRIVER_VERSION
DRIVER_VERSION = 1.35
endif

ifndef NON_RAID

SUPPORT_ARRAY = 1

ifndef DRIVER_REBUILD
DRIVER_REBUILD = 1
endif

ifndef SUPPORT_IOCTL
SUPPORT_IOCTL = 1
endif

endif

ifdef SUPPORT_SATA
SUPPORT_SATA = 1
endif

ifndef HPT372N
HPT372N = 1
endif
#
# Function selecting.
#
FUNCSELECT = 

ifeq ($(HPT372N), 1)
FUNCSELECT += -DHPT372N 
endif

ifeq ($(USE_PCI_CLK), 1)
FUNCSELECT += -DUSE_PCI_CLK
else
FUNCSELECT += -DDPLL_SWITCH -DFORCE_133
endif

ifeq ($(DRIVER_REBUILD), 1)
FUNCSELECT += -DDRIVER_REBUILD 
endif

ifeq ($(SUPPORT_ARRAY), 1)
FUNCSELECT += -DSUPPORT_ARRAY
endif

ifeq ($(SUPPORT_IOCTL), 1)
FUNCSELECT += -DSUPPORT_IOCTL
endif

ifeq ($(SUPPORT_ALARM), 1)
FUNCSELECT += -DSUPPORT_ALARM
endif

ifeq ($(SUPPORT_SATA), 1)
FUNCSELECT += -DSUPPORT_SATA
DRIVER_VERSION = 1.01s
endif

#
# Debug Options:
#
DEBUGOPT = -O2

ifeq ($(DEBUG),1)
DEBUGOPT += -DDEBUG
ifdef DEBUG_LEVEL
DEBUGOPT += -DDEBUG_LEVEL=$(DEBUG_LEVEL)
else
DEBUGOPT += -DDEBUG_LEVEL=1
endif
endif

CC = gcc

COMPANYDEF = -DHIGHPOINT

CFLAGS = ${COMPANYDEF} ${COMPNAMES} ${FUNCSELECT} ${DEBUGOPT} ${INCLS} -Wall \
		-Wstrict-prototypes -fomit-frame-pointer 
		
.c.o:
	$(CC) $(CFLAGS) -c $*.c
